/* If you wish to program your own Hamiltonian, you have to provide
   four routines in the file apply_h.c : */

/* Applying the Hamiltonian on src, yielding the result in dst */

extern void apply_internal_ham(struct vector *src, struct vector *dst, char *name);

/* Routine to compute correlation functions with respect to the vector in src
   (put an empty one, if you don't need it) */

extern void compute_correl(struct vector *src, FILE *fpo);

/* An initialization routine - should return the dimension of the
   vector space */

extern long init_interal_h();

/* A cleanup routine */

extern void exit_interal_h();

/* *************************************
   Some (machine-dependent) data types */

/* Determines maximal dimension of Sz-subspace
   Recommended: 32 Bit
   (only for very big problems you will need more
   than that) */

typedef unsigned int LONG;

/* Determines maximal dimension of momentum-subspace
   (can be different from LONG data type, but is
   usually the same)
   Recommended: 32 Bit
   (only for very big problems you will need more
   than that)
   Note: Some of the implementions do not use SLONG
         at all, but rather the LONG data type */

typedef unsigned int SLONG;

/* Some integer prefactor
   Recommended: 16 Bit */

typedef short INT;
