/* Standard-Definitions */
#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <limits.h>
#include <float.h>
/* Definitions for that program */
#include "useful.h"
#include "complex.h"
#include "variables.h"
#include "text.h"

/* vordefinierte Variablen */

static UBYTE i_text[] = "i";
static UBYTE pi_text[] = "pi";
static UBYTE e_text[] = "e";

static struct variable pi_var = {0, pi_text, PI, 0};
static struct variable i_var = {&pi_var, i_text, 0, 1};
static struct variable e_var = {&i_var, e_text, E_CONST, 0};

#define VAR_LIST (&e_var)
#define VAR_START pi_var.next

/* *******************************************
   Verwaltung von Variablen */

/* Alle Variablen freigeben */

void free_variables()
 {
   struct variable *ptr, *hptr;

   for(ptr=VAR_START; ptr; ptr=hptr)
    {
      hptr=ptr->next;
      free(ptr->text);
      free(ptr);
    }
   VAR_START=0;
 }

/* Eine Variable allocatieren */

void assign_variable(UBYTE *text, COMPLEX *value)
 {
   UBYTE *htext;
   struct variable *ptr;
   register int i;

   for(ptr=VAR_START; ptr; ptr=ptr->next)       /* Variablen ueberschreiben */
    if(compare(text, ptr->text))
      {
        ptr->re = value->re;
        ptr->im = value->im;
        return;
      }

   htext=(UBYTE *)malloc(strlen(text) + 1);              /* Text speichern */
   if(! htext)
     {
        display_error_text("Out of memory while assigning variable '%s'", text);
        return;
     }
   for(i=0; htext[i] = text[i]; i++)
         ;

   ptr=(struct variable *)malloc(sizeof(struct variable));
   if(! ptr)
    {
        free(htext);
        display_error_text("Out of memory while assigning variable '%s'", text);
        return;
    }
   ptr->text=htext;
   ptr->re=value->re;
   ptr->im=value->im;
   ptr->next=VAR_START;
   VAR_START=ptr;
 }

/* Eine Variable suchen */

struct variable *find_variable(UBYTE *text)
 {
   struct variable *ptr;

   for(ptr=VAR_LIST; ptr; ptr=ptr->next)
    if(compare(ptr->text, text))
       return(ptr);

   return(0);
 }
